diff --git a/src/mongo/db/pipeline/accumulator_min_max.cpp b/src/mongo/db/pipeline/accumulator/accumulator_min_max.cpp
similarity index 95%
rename from src/mongo/db/pipeline/accumulator_min_max.cpp
rename to src/mongo/db/pipeline/accumulator/accumulator_min_max.cpp
index d0d3758487..855f94c157 100644
--- a/src/mongo/db/pipeline/accumulator_min_max.cpp
+++ b/src/mongo/db/pipeline/accumulator/accumulator_min_max.cpp
@@ -29,11 +29,11 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/accumulator.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
 
 #include "mongo/db/exec/document_value/value.h"
-#include "mongo/db/pipeline/accumulation_statement.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/accumulator/accumulation_statement.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/window_function/window_function_expression.h"
 #include "mongo/db/pipeline/window_function/window_function_min_max.h"
 
diff --git a/src/mongo/db/pipeline/accumulator_push.cpp b/src/mongo/db/pipeline/accumulator/accumulator_push.cpp
similarity index 97%
rename from src/mongo/db/pipeline/accumulator_push.cpp
rename to src/mongo/db/pipeline/accumulator/accumulator_push.cpp
index cf3daa632a..206ff56e00 100644
--- a/src/mongo/db/pipeline/accumulator_push.cpp
+++ b/src/mongo/db/pipeline/accumulator/accumulator_push.cpp
@@ -29,10 +29,10 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/accumulator.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
 
 #include "mongo/db/exec/document_value/value.h"
-#include "mongo/db/pipeline/accumulation_statement.h"
+#include "mongo/db/pipeline/accumulator/accumulation_statement.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/db/pipeline/window_function/window_function_expression.h"
 #include "mongo/db/pipeline/window_function/window_function_push.h"
diff --git a/src/mongo/db/pipeline/accumulator_rank.cpp b/src/mongo/db/pipeline/accumulator/accumulator_rank.cpp
similarity index 95%
rename from src/mongo/db/pipeline/accumulator_rank.cpp
rename to src/mongo/db/pipeline/accumulator/accumulator_rank.cpp
index 1ac0912744..3c530fc55b 100644
--- a/src/mongo/db/pipeline/accumulator_rank.cpp
+++ b/src/mongo/db/pipeline/accumulator/accumulator_rank.cpp
@@ -32,11 +32,11 @@
 #include <cmath>
 #include <limits>
 
-#include "mongo/db/pipeline/accumulator_for_window_functions.h"
+#include "mongo/db/pipeline/accumulator/accumulator_for_window_functions.h"
 
 #include "mongo/db/exec/document_value/value.h"
-#include "mongo/db/pipeline/accumulation_statement.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/accumulator/accumulation_statement.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/window_function/window_function_expression.h"
 #include "mongo/util/summation.h"
 
diff --git a/src/mongo/db/pipeline/accumulator_std_dev.cpp b/src/mongo/db/pipeline/accumulator/accumulator_std_dev.cpp
similarity index 96%
rename from src/mongo/db/pipeline/accumulator_std_dev.cpp
rename to src/mongo/db/pipeline/accumulator/accumulator_std_dev.cpp
index e2208d92ff..2839088f9a 100644
--- a/src/mongo/db/pipeline/accumulator_std_dev.cpp
+++ b/src/mongo/db/pipeline/accumulator/accumulator_std_dev.cpp
@@ -29,12 +29,12 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/accumulator.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
 
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/value.h"
-#include "mongo/db/pipeline/accumulation_statement.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/accumulator/accumulation_statement.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/db/pipeline/window_function/window_function_expression.h"
 #include "mongo/db/pipeline/window_function/window_function_stddev.h"
diff --git a/src/mongo/db/pipeline/accumulator_sum.cpp b/src/mongo/db/pipeline/accumulator/accumulator_sum.cpp
similarity index 97%
rename from src/mongo/db/pipeline/accumulator_sum.cpp
rename to src/mongo/db/pipeline/accumulator/accumulator_sum.cpp
index c0033f281c..7564f01a3d 100644
--- a/src/mongo/db/pipeline/accumulator_sum.cpp
+++ b/src/mongo/db/pipeline/accumulator/accumulator_sum.cpp
@@ -32,11 +32,10 @@
 #include <cmath>
 #include <limits>
 
-#include "mongo/db/pipeline/accumulator.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
 
 #include "mongo/db/exec/document_value/value.h"
-#include "mongo/db/pipeline/accumulation_statement.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/accumulator/accumulation_statement.h"
 #include "mongo/db/pipeline/window_function/window_function_count.h"
 #include "mongo/db/pipeline/window_function/window_function_expression.h"
 #include "mongo/db/pipeline/window_function/window_function_sum.h"
diff --git a/src/mongo/db/pipeline/accumulator_test.cpp b/src/mongo/db/pipeline/accumulator/accumulator_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/accumulator_test.cpp
rename to src/mongo/db/pipeline/accumulator/accumulator_test.cpp
index d5a07d0b3b..2543b960a0 100644
--- a/src/mongo/db/pipeline/accumulator_test.cpp
+++ b/src/mongo/db/pipeline/accumulator/accumulator_test.cpp
@@ -36,9 +36,9 @@
 
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/document_value_test_util.h"
-#include "mongo/db/pipeline/accumulation_statement.h"
-#include "mongo/db/pipeline/accumulator.h"
-#include "mongo/db/pipeline/accumulator_for_window_functions.h"
+#include "mongo/db/pipeline/accumulator/accumulation_statement.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
+#include "mongo/db/pipeline/accumulator/accumulator_for_window_functions.h"
 #include "mongo/db/pipeline/expression_context_for_test.h"
 #include "mongo/db/query/collation/collator_interface_mock.h"
 #include "mongo/dbtests/dbtests.h"
diff --git a/src/mongo/db/pipeline/document_source_change_stream.cpp b/src/mongo/db/pipeline/change_stream/document_source_change_stream.cpp
similarity index 93%
rename from src/mongo/db/pipeline/document_source_change_stream.cpp
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream.cpp
index c4de783703..f2c0cd233e 100644
--- a/src/mongo/db/pipeline/document_source_change_stream.cpp
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream.cpp
@@ -29,29 +29,29 @@
 
 #define MONGO_LOGV2_DEFAULT_COMPONENT ::mongo::logv2::LogComponent::kCommand
 
-#include "mongo/db/pipeline/document_source_change_stream.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream.h"
 
 #include "mongo/bson/simple_bsonelement_comparator.h"
 #include "mongo/db/bson/bson_helper.h"
 #include "mongo/db/commands/feature_compatibility_version_documentation.h"
 #include "mongo/db/pipeline/aggregate_command_gen.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_check_invalidate.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_check_resumability.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_check_topology_change.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_close_cursor.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_ensure_resume_token_present.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_handle_topology_change.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_lookup_post_image.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_lookup_pre_image.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_oplog_match.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_transform.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_unwind_transactions.h"
 #include "mongo/db/pipeline/change_stream_constants.h"
 #include "mongo/db/pipeline/change_stream_helpers_legacy.h"
 #include "mongo/db/pipeline/document_path_support.h"
-#include "mongo/db/pipeline/document_source_change_stream_check_invalidate.h"
-#include "mongo/db/pipeline/document_source_change_stream_check_resumability.h"
-#include "mongo/db/pipeline/document_source_change_stream_check_topology_change.h"
-#include "mongo/db/pipeline/document_source_change_stream_close_cursor.h"
-#include "mongo/db/pipeline/document_source_change_stream_ensure_resume_token_present.h"
-#include "mongo/db/pipeline/document_source_change_stream_handle_topology_change.h"
-#include "mongo/db/pipeline/document_source_change_stream_lookup_post_image.h"
-#include "mongo/db/pipeline/document_source_change_stream_lookup_pre_image.h"
-#include "mongo/db/pipeline/document_source_change_stream_oplog_match.h"
-#include "mongo/db/pipeline/document_source_change_stream_transform.h"
-#include "mongo/db/pipeline/document_source_change_stream_unwind_transactions.h"
-#include "mongo/db/pipeline/document_source_limit.h"
-#include "mongo/db/pipeline/document_source_sort.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source_limit.h"
+#include "mongo/db/pipeline/document_source/document_source_sort.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 #include "mongo/db/pipeline/resume_token.h"
 #include "mongo/db/query/query_knobs_gen.h"
diff --git a/src/mongo/db/pipeline/document_source_change_stream.h b/src/mongo/db/pipeline/change_stream/document_source_change_stream.h
similarity index 97%
rename from src/mongo/db/pipeline/document_source_change_stream.h
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream.h
index 29b67fe526..d76ab0e224 100644
--- a/src/mongo/db/pipeline/document_source_change_stream.h
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream.h
@@ -31,11 +31,11 @@
 
 #include <type_traits>
 
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_gen.h"
 #include "mongo/db/pipeline/change_stream_constants.h"
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_change_stream_gen.h"
-#include "mongo/db/pipeline/document_source_match.h"
-#include "mongo/db/pipeline/document_source_single_document_transformation.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source_match.h"
+#include "mongo/db/pipeline/document_source/document_source_single_document_transformation.h"
 #include "mongo/db/pipeline/field_path.h"
 #include "mongo/db/pipeline/resume_token.h"
 #include "mongo/db/query/query_feature_flags_gen.h"
diff --git a/src/mongo/db/pipeline/document_source_change_stream_check_invalidate.cpp b/src/mongo/db/pipeline/change_stream/document_source_change_stream_check_invalidate.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_change_stream_check_invalidate.cpp
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream_check_invalidate.cpp
index 10b60f5530..60c171ea1b 100644
--- a/src/mongo/db/pipeline/document_source_change_stream_check_invalidate.cpp
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream_check_invalidate.cpp
@@ -31,8 +31,8 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_change_stream.h"
-#include "mongo/db/pipeline/document_source_change_stream_check_invalidate.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_check_invalidate.h"
 #include "mongo/db/query/query_feature_flags_gen.h"
 #include "mongo/util/assert_util.h"
 
diff --git a/src/mongo/db/pipeline/document_source_change_stream_check_invalidate.h b/src/mongo/db/pipeline/change_stream/document_source_change_stream_check_invalidate.h
similarity index 97%
rename from src/mongo/db/pipeline/document_source_change_stream_check_invalidate.h
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream_check_invalidate.h
index 30dc1b6eed..e81efe4732 100644
--- a/src/mongo/db/pipeline/document_source_change_stream_check_invalidate.h
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream_check_invalidate.h
@@ -29,8 +29,9 @@
 
 #pragma once
 
+#include "mongo/db/pipeline/change_stream/document_source_change_stream.h"
 #include "mongo/db/pipeline/change_stream_invalidation_info.h"
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_change_stream_check_resumability.cpp b/src/mongo/db/pipeline/change_stream/document_source_change_stream_check_resumability.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_change_stream_check_resumability.cpp
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream_check_resumability.cpp
index c22ea8d5c7..936b26c792 100644
--- a/src/mongo/db/pipeline/document_source_change_stream_check_resumability.cpp
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream_check_resumability.cpp
@@ -30,7 +30,7 @@
 #include "mongo/platform/basic.h"
 
 #include "mongo/db/curop.h"
-#include "mongo/db/pipeline/document_source_change_stream_check_resumability.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_check_resumability.h"
 #include "mongo/db/query/query_feature_flags_gen.h"
 #include "mongo/db/repl/oplog_entry.h"
 
diff --git a/src/mongo/db/pipeline/document_source_change_stream_check_resumability.h b/src/mongo/db/pipeline/change_stream/document_source_change_stream_check_resumability.h
similarity index 95%
rename from src/mongo/db/pipeline/document_source_change_stream_check_resumability.h
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream_check_resumability.h
index 21fad09765..5b2a0e2508 100644
--- a/src/mongo/db/pipeline/document_source_change_stream_check_resumability.h
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream_check_resumability.h
@@ -29,11 +29,11 @@
 
 #pragma once
 
+#include "mongo/db/pipeline/change_stream/document_source_change_stream.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_gen.h"
 #include "mongo/db/pipeline/change_stream_constants.h"
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_change_stream.h"
-#include "mongo/db/pipeline/document_source_change_stream_gen.h"
-#include "mongo/db/pipeline/document_source_sort.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source_sort.h"
 #include "mongo/db/pipeline/resume_token.h"
 #include "mongo/db/query/query_knobs_gen.h"
 
diff --git a/src/mongo/db/pipeline/document_source_change_stream_check_topology_change.cpp b/src/mongo/db/pipeline/change_stream/document_source_change_stream_check_topology_change.cpp
similarity index 97%
rename from src/mongo/db/pipeline/document_source_change_stream_check_topology_change.cpp
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream_check_topology_change.cpp
index 724f6c1338..854dae916e 100644
--- a/src/mongo/db/pipeline/document_source_change_stream_check_topology_change.cpp
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream_check_topology_change.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_change_stream_check_topology_change.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_check_topology_change.h"
 
 #include "mongo/db/pipeline/change_stream_topology_change_info.h"
 
diff --git a/src/mongo/db/pipeline/document_source_change_stream_check_topology_change.h b/src/mongo/db/pipeline/change_stream/document_source_change_stream_check_topology_change.h
similarity index 96%
rename from src/mongo/db/pipeline/document_source_change_stream_check_topology_change.h
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream_check_topology_change.h
index 850130359e..f41d82896b 100644
--- a/src/mongo/db/pipeline/document_source_change_stream_check_topology_change.h
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream_check_topology_change.h
@@ -29,8 +29,8 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_change_stream.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_change_stream_close_cursor.cpp b/src/mongo/db/pipeline/change_stream/document_source_change_stream_close_cursor.cpp
similarity index 97%
rename from src/mongo/db/pipeline/document_source_change_stream_close_cursor.cpp
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream_close_cursor.cpp
index a7db8e647a..75112cb8d5 100644
--- a/src/mongo/db/pipeline/document_source_change_stream_close_cursor.cpp
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream_close_cursor.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_change_stream_close_cursor.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_close_cursor.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_change_stream_close_cursor.h b/src/mongo/db/pipeline/change_stream/document_source_change_stream_close_cursor.h
similarity index 94%
rename from src/mongo/db/pipeline/document_source_change_stream_close_cursor.h
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream_close_cursor.h
index 16a1e13f2d..5b1fd91f24 100644
--- a/src/mongo/db/pipeline/document_source_change_stream_close_cursor.h
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream_close_cursor.h
@@ -29,10 +29,10 @@
 
 #pragma once
 
+#include "mongo/db/pipeline/change_stream/document_source_change_stream.h"
 #include "mongo/db/pipeline/change_stream_constants.h"
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_change_stream.h"
-#include "mongo/db/pipeline/document_source_sort.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source_sort.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_change_stream_ensure_resume_token_present.cpp b/src/mongo/db/pipeline/change_stream/document_source_change_stream_ensure_resume_token_present.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_change_stream_ensure_resume_token_present.cpp
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream_ensure_resume_token_present.cpp
index 7ea37e67da..c651bfe380 100644
--- a/src/mongo/db/pipeline/document_source_change_stream_ensure_resume_token_present.cpp
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream_ensure_resume_token_present.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_change_stream_ensure_resume_token_present.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_ensure_resume_token_present.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_change_stream_ensure_resume_token_present.h b/src/mongo/db/pipeline/change_stream/document_source_change_stream_ensure_resume_token_present.h
similarity index 97%
rename from src/mongo/db/pipeline/document_source_change_stream_ensure_resume_token_present.h
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream_ensure_resume_token_present.h
index 57b9110791..1ec53a3721 100644
--- a/src/mongo/db/pipeline/document_source_change_stream_ensure_resume_token_present.h
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream_ensure_resume_token_present.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source_change_stream_check_resumability.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_check_resumability.h"
 
 namespace mongo {
 /**
diff --git a/src/mongo/db/pipeline/document_source_change_stream_handle_topology_change.cpp b/src/mongo/db/pipeline/change_stream/document_source_change_stream_handle_topology_change.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_change_stream_handle_topology_change.cpp
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream_handle_topology_change.cpp
index 962e48fe4b..9266820724 100644
--- a/src/mongo/db/pipeline/document_source_change_stream_handle_topology_change.cpp
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream_handle_topology_change.cpp
@@ -27,12 +27,12 @@
  *    it in the license file.
  */
 
-#include "mongo/db/pipeline/document_source_change_stream_handle_topology_change.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_handle_topology_change.h"
 
 #include <algorithm>
 
+#include "mongo/db/pipeline/change_stream/document_source_change_stream.h"
 #include "mongo/db/pipeline/change_stream_topology_change_info.h"
-#include "mongo/db/pipeline/document_source_change_stream.h"
 #include "mongo/db/pipeline/sharded_agg_helpers.h"
 #include "mongo/db/query/query_feature_flags_gen.h"
 #include "mongo/s/catalog/type_shard.h"
diff --git a/src/mongo/db/pipeline/document_source_change_stream_handle_topology_change.h b/src/mongo/db/pipeline/change_stream/document_source_change_stream_handle_topology_change.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_change_stream_handle_topology_change.h
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream_handle_topology_change.h
index 1d240be5e3..23099c6764 100644
--- a/src/mongo/db/pipeline/document_source_change_stream_handle_topology_change.h
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream_handle_topology_change.h
@@ -32,7 +32,7 @@
 #include <memory>
 
 #include "mongo/db/pipeline/change_stream_constants.h"
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 #include "mongo/s/query/document_source_merge_cursors.h"
 #include "mongo/s/shard_id.h"
 
diff --git a/src/mongo/db/pipeline/document_source_change_stream_lookup_post_image.cpp b/src/mongo/db/pipeline/change_stream/document_source_change_stream_lookup_post_image.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_change_stream_lookup_post_image.cpp
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream_lookup_post_image.cpp
index 8659f71e32..d8f8a76f51 100644
--- a/src/mongo/db/pipeline/document_source_change_stream_lookup_post_image.cpp
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream_lookup_post_image.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_change_stream_lookup_post_image.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_lookup_post_image.h"
 
 #include "mongo/bson/simple_bsonelement_comparator.h"
 
diff --git a/src/mongo/db/pipeline/document_source_change_stream_lookup_post_image.h b/src/mongo/db/pipeline/change_stream/document_source_change_stream_lookup_post_image.h
similarity index 97%
rename from src/mongo/db/pipeline/document_source_change_stream_lookup_post_image.h
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream_lookup_post_image.h
index 2a7c9666e6..8041af166f 100644
--- a/src/mongo/db/pipeline/document_source_change_stream_lookup_post_image.h
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream_lookup_post_image.h
@@ -29,8 +29,8 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_change_stream.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_change_stream_lookup_post_image_test.cpp b/src/mongo/db/pipeline/change_stream/document_source_change_stream_lookup_post_image_test.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_change_stream_lookup_post_image_test.cpp
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream_lookup_post_image_test.cpp
index 6672e54f1c..b0428086c1 100644
--- a/src/mongo/db/pipeline/document_source_change_stream_lookup_post_image_test.cpp
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream_lookup_post_image_test.cpp
@@ -40,9 +40,9 @@
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/exec/document_value/value.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_change_stream.h"
-#include "mongo/db/pipeline/document_source_change_stream_lookup_post_image.h"
-#include "mongo/db/pipeline/document_source_mock.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_lookup_post_image.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
 #include "mongo/db/pipeline/field_path.h"
 #include "mongo/db/pipeline/process_interface/stub_lookup_single_document_process_interface.h"
 
diff --git a/src/mongo/db/pipeline/document_source_change_stream_lookup_pre_image.cpp b/src/mongo/db/pipeline/change_stream/document_source_change_stream_lookup_pre_image.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_change_stream_lookup_pre_image.cpp
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream_lookup_pre_image.cpp
index b4a7c51a73..7b3e550ec6 100644
--- a/src/mongo/db/pipeline/document_source_change_stream_lookup_pre_image.cpp
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream_lookup_pre_image.cpp
@@ -32,7 +32,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_change_stream_lookup_pre_image.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_lookup_pre_image.h"
 
 #include "mongo/bson/simple_bsonelement_comparator.h"
 #include "mongo/db/transaction_history_iterator.h"
diff --git a/src/mongo/db/pipeline/document_source_change_stream_lookup_pre_image.h b/src/mongo/db/pipeline/change_stream/document_source_change_stream_lookup_pre_image.h
similarity index 97%
rename from src/mongo/db/pipeline/document_source_change_stream_lookup_pre_image.h
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream_lookup_pre_image.h
index 10e4028ee4..16dd4f7c1d 100644
--- a/src/mongo/db/pipeline/document_source_change_stream_lookup_pre_image.h
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream_lookup_pre_image.h
@@ -29,8 +29,8 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_change_stream.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_change_stream_oplog_match.cpp b/src/mongo/db/pipeline/change_stream/document_source_change_stream_oplog_match.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_change_stream_oplog_match.cpp
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream_oplog_match.cpp
index 5dd28772c6..bc924b495f 100644
--- a/src/mongo/db/pipeline/document_source_change_stream_oplog_match.cpp
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream_oplog_match.cpp
@@ -27,7 +27,7 @@
  *    it in the license file.
  */
 
-#include "mongo/db/pipeline/document_source_change_stream_oplog_match.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_oplog_match.h"
 #include "mongo/bson/bsonmisc.h"
 #include "mongo/db/bson/bson_helper.h"
 
diff --git a/src/mongo/db/pipeline/document_source_change_stream_oplog_match.h b/src/mongo/db/pipeline/change_stream/document_source_change_stream_oplog_match.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_change_stream_oplog_match.h
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream_oplog_match.h
index 68755f811b..cbf281e10d 100644
--- a/src/mongo/db/pipeline/document_source_change_stream_oplog_match.h
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream_oplog_match.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source_change_stream.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream.h"
 
 namespace mongo {
 /**
